//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 9
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 DarkGray
#property indicator_color4 DarkGray
#property indicator_color6 Yellow
#property indicator_color7 Red
#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 2
#property indicator_width4 2
#property indicator_color8 Lime
#property indicator_color9 Red
//
//
//
//
//

extern int  HMA1Period       = 5;
extern int  HMA1Price        = PRICE_WEIGHTED;
extern int  HMA1Mode         = 3;
extern int  HMA2Period       = 5;
extern int  HMA2Price        = PRICE_WEIGHTED;
extern int  HMA2Mode         = 3;
extern int  scost            = 1;
extern bool AlertsOn         = false;
extern bool AlertsOnCurrent  = true;
extern bool AlertsMessage    = true;
extern bool AlertsSound      = false;
extern bool AlertsEmail      = false;
 bool RibbonOff       = false;
//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double trend[];
double trendUp[];
double trendDn[];

double buffer5[];
double buffer6[];
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);
   
   SetIndexBuffer(0,buffer3); SetIndexStyle(0,DRAW_LINE,0,2);
   
   SetIndexBuffer(1,buffer4); SetIndexStyle(1,DRAW_LINE,0,2);
   SetIndexBuffer(2,buffer1);SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(3,buffer2);SetIndexStyle(3,DRAW_NONE);
   SetIndexBuffer(4,trend);

   SetIndexBuffer(5,trendUp);SetIndexStyle(5,DRAW_ARROW,0,3);
   SetIndexArrow(5,241);
  
    SetIndexBuffer(6,trendDn);SetIndexStyle(6,DRAW_ARROW,0,3);
   SetIndexArrow(6,242);
   
   SetIndexBuffer(7,buffer5); SetIndexStyle(7,DRAW_LINE,0,2);
  
   SetIndexBuffer(8,buffer6); SetIndexStyle(8,DRAW_LINE,0,2);
   
   
   
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      buffer1[i] = iMA(NULL,0,HMA1Period,0,HMA1Mode,HMA1Price,i);
      buffer2[i] = iMA(NULL,0,HMA2Period,scost,HMA2Mode,HMA2Price,i);
    //  buffer3[i] = buffer1[i];
    //  buffer4[i] = buffer2[i];
      trend[i]   = trend[i+1];
         if (buffer1[i]>buffer2[i]) trend[i] =  1;
         if (buffer1[i]<buffer2[i]) trend[i] = -1;
         
         
         if(buffer1[i]> buffer2[i]&& buffer1[i+1]< buffer2[i+1]
        // && buffer1[i+10]/Point-buffer2[i+10]/Point<-30 
          )
             trendUp[i]   = Low[i] -0.00009;  
              
             
              if(buffer1[i]< buffer2[i]&& buffer1[i+1]> buffer2[i+1] )
             trendDn[i]   = High[i] +0.00009;  
                
                
                
                
                
                
                
               if(buffer1[i]> buffer2[i]
        // && buffer1[i+10]/Point-buffer2[i+10]/Point<-30 
          )
             
              buffer3[i] = buffer1[i];
             
              if(buffer1[i]< buffer2[i] )
            // trendDn[i]   = buffer4[i] +0.00009;  
                buffer4[i] = buffer1[i];     
             
          
             
             
               if(buffer1[i]> buffer2[i]
        // && buffer1[i+10]/Point-buffer2[i+10]/Point<-30 
          )
             
              buffer5[i] = buffer2[i];
             
              if(buffer1[i]< buffer2[i] )
            // trendDn[i]   = buffer4[i] +0.00009;  
                buffer6[i] = buffer2[i];     
             
            
             
             
                
                
                
   }
   manageAlerts();
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//


double workHull[][4];
double iHull(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workHull,0)!= Bars) ArrayResize(workHull,Bars); r=Bars-r-1;

   //
   //
   //
   //
   //

      int HmaPeriod  = MathMax(period,2);
      int HalfPeriod = MathFloor(HmaPeriod/2);
      int HullPeriod = MathFloor(MathSqrt(HmaPeriod));
      double hma,hmw,weight; instanceNo *= 2;

         workHull[r][instanceNo] = price;

         //
         //
         //
         //
         //
               
         hmw = HalfPeriod; hma = hmw*price; 
            for(int k=1; k<HalfPeriod && (r-k)>=0; k++)
            {
               weight = HalfPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];  
            }             
            workHull[r][instanceNo+1] = 2.0*hma/hmw;

         hmw = HmaPeriod; hma = hmw*price; 
            for(k=1; k<period && (r-k)>=0; k++)
            {
               weight = HmaPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];
            }             
            workHull[r][instanceNo+1] -= hma/hmw;

         //
         //
         //
         //
         //
         
         hmw = HullPeriod; hma = hmw*workHull[r][instanceNo+1];
            for(k=1; k<HullPeriod && (r-k)>=0; k++)
            {
               weight = HullPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][1+instanceNo];  
            }
   return(hma/hmw);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (AlertsOn)
   {
      if (AlertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

      if (trend[whichBar]!= trend[whichBar+1])
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (trend[whichBar] ==  1) doAlert(time1,mess1," hull ribbon trend changed to up");
            if (trend[whichBar] == -1) doAlert(time1,mess1," hull ribbon trend changed to down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(Symbol()+" Hull ribbon",message);
          if (AlertsSound)   PlaySound("alert2.wav");
   }
}